﻿

/**
* Definice proměnné
*/
function executeExample1() {

    // Základní definice proměnné
    var studentAge = 21;

    // Vypíšeme typ proměnné
    console.log("Typ proměnné 'studentAge':", typeof studentAge);

    // Změníme hodnotu na textovou
    studentAge = "jednadvacet";

    // Vypíšeme typ proměnné
    console.log("Typ proměnné 'studentAge':", typeof studentAge);

    // Změníme hodnotu na objekt
    studentAge = {
        years: 21,
        months: 5,
        days: 13
    };

    // Vypíšeme typ proměnné
    console.log("Typ proměnné 'studentAge':", typeof studentAge);


    // Porovnávání proměnných
    var a = "10";
    var b = 10;
    console.log("Je pravda, že 'a' == 'b':", a == b);
    console.log("Je pravda, že 'a' === 'b':", a === b);
}





/**
* Funkce
*/
function executeExample2() {


    // Základní definice funkce
    function getTwo()
    {
        return 2;
    }
    console.log("Návratová hodnota funkce 'getTwo'", getTwo());


    // Funkce s pevným počtem argumentů
    function sum(a, b)
    {
        return a + b;
    }
    console.log("Součet šísel 8 a 46 je ", sum(8, 46));


    // Funkce s volitelným počtem argumentů
    function sumN()
    {
        var sum = 0;
        for (var i = 0; i < arguments.length; i++)
        {
            sum += arguments[i];
        }
        return sum;
    }
    console.log("Součet šísel 1, 2, 3, 4, 5 a 6 je ", sumN(1, 2, 3, 4, 5, 6));

}






/**
* Pole a objekty
*/
function executeExample3() {

    // Základní definice pole
    var myArray1 = [1, 2, 3, 4];
    console.log("Pole o 4 hodnotách 1:", myArray1);


    // Alternativní definice
    var myArray2 = new Array();
    myArray2[0] = 1; // Pomocí indexu prvku
    myArray2[1] = 2;
    myArray2.push(3); // Pomocí metody 'push'
    myArray2.push(4);
    console.log("Pole o 4 hodnotách 2:", myArray2);


    console.log("Typ pole je:", typeof myArray2); // Pole != pole v C, ale spíše List v C#


    // Oddělovač výstupu
    console.log("\n\n\n");


    // Součet čísel v poli
    var sum = 0;
    for (var i = 0; i < myArray2.length; i++) {
        sum += myArray2[i];
    }
    console.log("Součet hodnot v poli:", sum);


    // Oddělovač výstupu
    console.log("\n\n\n");


    // Spojení dvou polí
    console.log("Spojení dvou polí:", [1, 2, 3].concat([4, 5, 6]));

    // Spojení dvou polí
    console.log("Spojení prvků pole:", [1, 2, 3].join(' + '));


    // Odstranění/přidání prvku na začátku/konci pole
    var myArray3 = [1, 2, 3, 4];

    myArray3.push(5);
    console.log("Přidání prvku na konce pole:", myArray3);

    myArray3.unshift(0);
    console.log("Přidání prvku na začátek pole:", myArray3);

    myArray3.pop();
    console.log("Odstranění prvku na konci pole:", myArray3);

    myArray3.shift();
    console.log("Odstranění prvku na začátek pole:", myArray3);



    // Oddělovač výstupu
    console.log("\n\n\n");


    // Základní definice objektu
    var myObject1 = {};
    console.log("Prázdný objekt:", myObject1);

    // Objekt s atributy
    var myObject2 = {
        firstName: "Pepa",
        lastName: "Novák",
        age: 21
    };
    console.log("Objekt s atributy:", myObject2);
    console.log("Hodnota atributu 'firstName':", myObject2.firstName);


    // Alternativní definice objektu
    var myObject3 = new Object();
    myObject3['firstName'] = "Pepa";
    myObject3['lastName'] = "Novák";
    myObject3['age'] = "21";
    console.log("Alternativní definice objektu:", myObject3);

}







/**
* Viditelnost proměnných
*/
function executeExample4() {

    // Globální vs lokální proměnná (význam slovíčka "var")
    function setVariables(a, b)
    {
        var variableA = a;
        variableB = b;

        console.log("Hodnoty proměnných uvnitř funkce -", "variableA:", variableA, ", variableB:", variableB);
    }
    setVariables(12, 20);

    try{
        console.log("Hodnot a proměnné 'variableA':", variableA);
    } catch (e)
    {
        console.log("Chyba při získávání proměnné 'variableA':", e.message);
    }
    console.log("Hodnot a proměnné 'variableB':", variableB);



    // Oddělovač výstupu
    console.log("\n\n\n");

    // Deklarace proměnné na objektu 'window'
    window['variableC'] = "abcd";
    console.log("Globální proměnné = proměnné na objektu 'window':", variableC === window['variableC']);




    // Oddělovač výstupu
    console.log("\n\n\n");



    function myFunction1() {
        var a = 5;
        var b = 10;
        console.log("'myFunction1' (před voláním 'myFunction2') -", "a:", a, "b:", b);

        function myFunction2() {
            var a = 20;
            b = 11;
            var c = 8;
            console.log("'myFunction2' - ", "a:", a, "b:", b);
        }
        myFunction2();

        console.log("'myFunction1' (po volání 'myFunction2') -", "a:", a, "b:", b, "c: není viditelná");
    }
    myFunction1();



    // Oddělovač výstupu
    console.log("\n\n\n");



    // Proč je mimo jiné důležitá viditelnost? (chceme se spožděním vypsat hodnoty 0 až 4)
    for (var i = 0; i < 5; i++) {
        setTimeout(function () {
            console.log("Hodnota 'i':", i);
        }, 50);
    }


    // Tentýž kód s korektní viditelností
    function delay(j){
        setTimeout(function () {
            console.log("Hodnota 'j':", j);
        }, 100);
    }
    for (var j = 0; j < 5; j++) {
        delay(j);
    }


}





/**
* Zapouzdření
*/
function executeExample5() {


    // Anonymní funkce (zapouzdření)
    (function () {
        var a = 5;
        var b = 10;
        console.log("Výpis z anonymní funkce:", a + b);
    })();

    console.log("\n");


    // Anonymní funkce 2 - již známý příklad s viditelností
    for (var i = 0; i < 5; i++) {
        (function (index) {
            setTimeout(function () {
                console.log("Hodnota 'i':", index);
            }, 100);
        })(i);
    }
    


}